#ifndef LTM_TEMPLATE
#define LTM_TEMPLATE

#include <stdlib.h>

#include "ltm/common.h"

/**
 * Represents a compiled template
 */
typedef struct ltm_template ltm_template;

/**
 * Compile the given template.
 *
 * @param out where to store pointer to newly allocated `ltm_template`
 * @param template nul-terminated string containing the template
 */
ltm_err ltm_template_compile(ltm_template **out, const char *template);

/**
 * Compile the given template with a given length.
 *
 * @param out where to store pointer to newly allocated `ltm_template`
 * @param template char buffer containing the template
 * @param len length of the char buffer
 */
ltm_err ltm_template_compile_n(ltm_template **out, const char *template,
                               size_t len);

#endif
